package com.denizenscript.clientizen.debuggui;

import io.github.cottonmc.cotton.gui.client.BackgroundPainter;
import io.github.cottonmc.cotton.gui.client.LightweightGuiDescription;
import io.github.cottonmc.cotton.gui.client.ScreenDrawing;
import io.github.cottonmc.cotton.gui.widget.WTabPanel;
import io.github.cottonmc.cotton.gui.widget.data.Color;
import net.minecraft.class_1041;
import net.minecraft.class_124;
import net.minecraft.class_2561;
import net.minecraft.class_310;

public class ClientizenDebugGUI extends LightweightGuiDescription {

    public static final int TAB_HEIGHT = 30; // WTabPanel.TAB_HEIGHT
    public static final class_2561 CONSOLE_TITLE = class_2561.method_43471("clientizen.debug.tab.console").method_27692(class_124.field_1067);
    public static final class_2561 OPTIONS_TITLE = class_2561.method_43471("clientizen.debug.tab.options").method_27692(class_124.field_1067);

    public DebugConsole console = new DebugConsole();

    public ClientizenDebugGUI() {
        class_1041 window = class_310.method_1551().method_22683();
        WTabPanel mainPanel = new WTabPanel();
        mainPanel.setSize(window.method_4486(), window.method_4502());
        setRootPanel(mainPanel);
        mainPanel.add(console, tab -> tab.title(CONSOLE_TITLE));
        mainPanel.add(new DebugOptionsMenu(), tab -> tab.title(OPTIONS_TITLE));
        mainPanel.validate(this);
    }

    public void onClose() {
        console.onClose();
    }

    public static BackgroundPainter transparent;

    static {
        int color = Color.rgb(256, 0, 0, 0).toRgb();
        // Based on ScreenDrawing#drawGuiPanel(MatrixStack matrices, int x, int y, int width, int height, int panelColor)
        int shadowColor = ScreenDrawing.multiplyColor(color, 0.50f);
        int hilightColor = ScreenDrawing.multiplyColor(color, 1.25f);
        transparent = (matrices, left, top, panel) -> {
            ScreenDrawing.drawGuiPanel(matrices, left, top, panel.getWidth(), panel.getHeight(), shadowColor, color, hilightColor, color);
        };
    }

    @Override
    public void addPainters() {
        rootPanel.setBackgroundPainter(transparent);
    }
}
